package com.javacodegeeks;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.commons.dbcp.BasicDataSource;

public class BasicDataSourceExample {


	public static void main(String args[]) throws SQLException {
		BasicDataSource dataSource = new BasicDataSource();
		dataSource.setDriverClassName("org.sqlite.JDBC");
		dataSource.setUrl("jdbc:sqlite:test.db");
		createTable(dataSource);
		insertQuery(dataSource);
		selectQuery(dataSource);
		dropTable(dataSource);

	}

	private static void insertQuery(BasicDataSource dataSource) throws SQLException {
		Statement stmt = dataSource.getConnection().createStatement();
		String sql = "INSERT INTO Users VALUES('1','tom','chasing jerry')";
		stmt.executeUpdate(sql);
		sql = "INSERT INTO Users VALUES('2','jerry','eating chesse')";
		stmt.executeUpdate(sql);
		stmt.close();

	}

	private static void dropTable(BasicDataSource dataSource)
			throws SQLException {
		Statement stmt = dataSource.getConnection().createStatement();
		String sql = "DROP TABLE Users";
		stmt.executeUpdate(sql);
		stmt.close();
		System.out.println("Table dropped");

	}

	private static void createTable(BasicDataSource dataSource)
			throws SQLException {
		Statement stmt = dataSource.getConnection().createStatement();
		String sql = "CREATE TABLE 'Users' ('id'	TEXT,'name'	TEXT,'passion'	TEXT,PRIMARY KEY(id));";
		stmt.executeUpdate(sql);
		stmt.close();
		System.out.println("Table created");

	}

	private static void selectQuery(BasicDataSource dataSource)
			throws SQLException {
		Connection connection = null;
		PreparedStatement statement = null;
		System.out.println("*********************Selecting data************************");
		System.out.println();

		try {
			connection = dataSource.getConnection();
			statement = connection.prepareStatement("SELECT * FROM Users");
			ResultSet rs = statement.executeQuery();

			while (rs.next()) {
				String s = String.format("ID:%s Username:%s Passion:%s",
						rs.getString("id"), rs.getString("name"),
						rs.getString("passion"));
				System.out.println(s);
				System.out.println();
			}
			System.out.println("");
			System.out.println("*******************************************************");
		} catch (Exception e) {
			System.out.println(e.getMessage());
		} finally {
			if (statement != null)
				statement.close();
			if (connection != null)
				connection.close();
		}
	}
}
